stages:
  - build
  - linter
  - test

build:
  stage: build
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw package
  artifacts:
    paths:
      - target/demo-0.0.1-SNAPSHOT.jar

linter:
  stage: linter
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw spotbugs:spotbugs
  artifacts:
    paths:
      - target/demo-0.0.1-SNAPSHOT.jar

tests:
  stage: test
  image: maven
  parallel:
    matrix:
      - CLASSNAME: [ForumDAOUserListTests, PostDAOSetPostTests, ThreadDAOTreeSortTests, UserDAOChangeTests]
  script:
    - chmod +x mvnw
    - ./mvnw test -Dtest=$CLASSNAME
